numMixture = numVertical; 
available = zeros(numImage, 1)+1.; 
SUM1mapLearn1 = cell(numImage, numOrient); 
for (img = 1:numImage)
    for (orient = 1:numOrient)
        SUM1mapLearn1{img, orient} = single(zeros(sizex, sizey)); 
    end
end
deformedTemplate = cell(1, numImage); % templates for training images 
for (img = 1 : numImage)
    deformedTemplate{img} = single(zeros(sizex, sizey));  
end
%% distribute examples into categories
for (it = 1 : numIteration)
SUM2scoreAll = zeros(numImage, numMixture);
for (cate = 1:numMixture)
    templateName = ['working/learnedTemplate' num2str(cate)]; 
    load(templateName); 
    SUM2scorecate = zeros(numImage, 1); 
    CgetSUM2(numOrient, subsample, ... % about active basis  
      numElement, numImage, sizex, sizey, MAX1map, ... % about training images 
      selectedOrient, selectedx, selectedy, selectedlambda, selectedLogZ, ...% learned parameters
      SUM2scorecate, available) % output template matching score
    SUM2scoreAll(:, cate) = SUM2scorecate+0.; 
end
num = zeros(numMixture, 1); 
example = zeros(numMixture, numImage); 
for (img = 1 : numImage)
     [max_SUM2, cate_img] = max(SUM2scoreAll(img, :));
     num(cate_img) = num(cate_img) + 1; 
     example(cate_img, num(cate_img)) = img; 
end
%% re-learn the template for each category
for (cate = 1:numMixture)
  for (k = 1:num(cate))
    img = example(cate, k); 
    for (orient = 1 : numOrient)
       Ccopy(SUM1mapLearn1{k, orient}, SUM1map{img, orient}, sizex, sizey); 
    end
  end
CsharedSketch(numOrient, locationShiftLimit, orientShiftLimit, subsample, ... % about active basis  
       numElement, num(cate), sizex, sizey, SUM1mapLearn1(1:num(cate), :), ... % about training images 
       halfFilterSize, Correlation, allSymbol(1, :), ... % about filters
       numStoredPoint, storedlambda, storedExpectation, storedLogZ, ... % about exponential model 
       selectedOrient, selectedx, selectedy, selectedlambda, selectedLogZ, SUM2score, ... % learned parameters
       commonTemplate, deformedTemplate); % learned templates 
   templateName = ['working/learnedTemplate' num2str(cate)]; 
   save(templateName, 'selectedOrient', 'selectedx', 'selectedy', 'selectedlambda', 'selectedLogZ'); 
%% display the results 
if (it==numIteration)
SUM2scorecate = SUM2score(1:num(cate))+0.; 
[SUM2scoresort, ind] = sort(SUM2scorecate, 'descend'); 
bx =0; by = 0; cc = 3;
col = 6; row = floor(num(cate)/col)+1;
Iout = zeros(row*sizex+(row-1)*(2*bx+cc), 2*col*sizey+(col-1)*(2*by+cc))+255; 
towrite = -commonTemplate; 
towrite = (255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
Iout(1:sizex, 1:sizey) = towrite;
k = -1;  
for (r = 1 : row)
    for (c = 1 : col)
        k = k+1; 
        if ((k>=1)&&(k<=num(cate)))
            img = example(cate, ind(k)); 
            towrite = Ifill{img}; 
            towrite = (255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
            Iout((r-1)*sizex+1+(r-1)*(2*bx+cc): r*sizex+(r-1)*(2*bx+cc), (c-1)*2*sizey+1+(c-1)*(2*by+cc): (c-1)*2*sizey+sizey+(c-1)*(2*by+cc)) = towrite; 
            towrite =  -deformedTemplate{ind(k)}; 
            towrite = (255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
            Iout((r-1)*sizex+1+(r-1)*(2*bx+cc) : r*sizex+(r-1)*(2*bx+cc), (c-1)*2*sizey+sizey+(c-1)*(2*by+cc)+1 : (c-1)*2*sizey+sizey+(c-1)*(2*by+cc)+sizey) =towrite;  
        end
    end
end
for (r = 1 : row-1)
  Iout(r*sizex+(r-1)*(2*bx+cc)+bx+1:r*sizex+(r-1)*(2*bx+cc)+bx+cc, :) = 0; 
end
for (c = 1 : col-1)
  Iout(:, c*(sizey*2)+(c-1)*(2*by+cc)+by+1:c*(sizey*2)+(c-1)*(2*by+cc)+by+cc) = 0; 
end
  outepsgif(Iout, ['mixture_' num2str(cate)]); 
end %i if 
end % cate
end % it
